/*
 * Generally useful stuff.
 */

#include "common.h"

double magnD(const double pq[D3]) {
  gsl_vector v;

  v.size= D3;
  v.stride= 1;
  v.data= (double*)pq;
  /* owner and block ought not to be used */

  return gsl_blas_dnrm2(&v);
}

double hypotD(const double p[D3], const double q[D3]) {
  int k;
  double pq[D3];

  K pq[k]= p[k] - q[k];
  return magnD(pq);
}

double hypotD2(const double p[D3], const double q[D3]) {
  int k;
  double d2= 0;
  
  K d2= ffsqa(p[k] - q[k], d2);
  return d2;
}

double hypotD2plus(const double p[D3], const double q[D3], double d2) {
  int k;
  K d2= ffsqa(p[k] - q[k], d2);
  return d2;
}

void xprod(double r[D3], const double a[D3], const double b[D3]) {
  r[0]= a[1]*b[2] - a[2]*b[1];
  r[1]= a[2]*b[0] - a[0]*b[2];
  r[2]= a[0]*b[1] - a[1]*b[0];
}

void diee(const char *what) { perror(what); exit(16); }
void flushoutput(void) { if (fflush(stdout)||ferror(stdout)) diee("stdout"); }
